; CAD_TXT.LSP

; ===================
; Cadre autour d'un texte
; ===================


(defun c:cad_txt ()

(setvar "cmdecho" 0)


(setq ent_txt (entget (car (entsel))))

; trouve la coordonne de la boite texte

(setq dim_txt (textbox ent_txt))

; trouve hauteur du texte

(setq ht_txt (cdr (assoc 40 ent_txt)))

; trouve angle du texte

(setq an_txt (cdr (assoc 50 ent_txt)))

; dfini le scu suivant l'angle du texte

(command "scu" "z" (* an_txt (/ 180 pi)))

; calcule les points pour construire le cadre

(setq pos1 (trans (cdr (assoc 10 ent_txt)) 0 1))
(setq pos2 (list (+ (car pos1) (car (cadr dim_txt))) (+ (cadr pos1) (cadr (cadr dim_txt)))))


; dimension  autour du texte

(setq posx1  (polar pos1(* 1.25 pi) (/  ht_txt 2)))

(setq posx2  (polar pos2 (* 0.25 pi) (/ ht_txt 2)))

(setq posx3 (list (car posx1) (cadr posx2)))

(setq posx4 (list (car posx2) (cadr posx1)))


; trace le cadre

(command "polylign" posx1 posx3 posx2 posx4 "c")

; revient sur le scu prcdent

(command "scu" "p")

(princ)

)

(princ "\n==> CAD_TXT")
(princ)